#ifndef __ADDRESS_H__
#define __ADDRESS_H__

#include <type.h>

/*
 * Direcciones virtuales
 */

#define KERNEL_HEAP	0x00400000

#define AUX_FRAME 0x1DFFF000

#define PROCESS_CODE 		0x40000000 // 1G
// Nota: PROCESS_CODE incluye .rodata
//#define PROCESS_DATA 		0x41000000 // 1G + 16M
//#define PROCESS_BSS 		0x42000000 // 1G + 32M
#define PROCESS_USR_STACK 	0x7FFFC000 // 2G - 16K
#define PROCESS_SVC_STACK 	0x7FFFF000 // 2G -  4K
#define PROCESS_HEAP 		0x60000000 // 1.5G

/*
 * src/script.ld (etiquetas)
 */

extern uint __system_stack;
extern uint __code_start, __code_end;
extern uint __rodata_start, __rodata_end;
extern uint __data_start, __data_end;
extern uint __bss_start , __bss_end;
extern uint __kernel_start, __kernel_end;

#define KERNEL_STACK 		((uint) &__system_stack)
#define KERNEL_CODE 		((uint) &__code_start)
#define KERNEL_CODE_SIZE 	(((uint) &__code_end) - KERNEL_CODE)
#define KERNEL_RODATA 		((uint) &__rodata_start)
#define KERNEL_RODATA_SIZE 	(((uint) &__rodata_end) - KERNEL_RODATA)
#define KERNEL_DATA 		((uint) &__data_start)
#define KERNEL_DATA_SIZE 	(((uint) &__data_end) - KERNEL_DATA)
#define KERNEL_BSS 			((uint) &__bss_start)
#define KERNEL_BSS_SIZE 	(((uint) &__bss_end) - KERNEL_BSS)
#define KERNEL 				((uint) &__kernel_start)
#define KERNEL_SIZE 		(((uint) &__kernel_end) - KERNEL)


#endif /* __ADDRESS_H__ */
