#include <debug.h>

const char* toHex(char *buffer, int size, uint32_t n)
{
	char temp[size];
	int temp_ix = 0, buffer_ix = 0;

	do
	{
		uint8_t c = (uint8_t) (n % 16);
		n = n / 16;

		if(c < 10)
			temp[temp_ix++] = '0' + c;
		else
			temp[temp_ix++] = 'A' + (c - 10);

	} while(n);

	buffer[buffer_ix++] = '0';
	buffer[buffer_ix++] = 'x';

	for(int i = 0; i < (8-temp_ix); i++)
		buffer[buffer_ix++] = '0';

	while(temp_ix)
		buffer[buffer_ix++] = temp[--temp_ix];

	buffer[buffer_ix] = 0;

	return buffer;
}

const char* toBin(char *buffer, int size, uint32_t n)
{
	char temp[size];
	int temp_ix = 0, buffer_ix = 0;

	do
	{
		temp[temp_ix++] = '0' + (uint8_t) (n % 2);
		n = n / 2;

	} while(n);

	buffer[buffer_ix++] = '0';
	buffer[buffer_ix++] = 'b';

	while(temp_ix)
		buffer[buffer_ix++] = temp[--temp_ix];

	buffer[buffer_ix] = 0;

	return buffer;
}

const char* toDec(char *buffer, int size, int n)
{
	char temp[size];
	int temp_ix = 0, buffer_ix = 0;

	if(n < 0)
	{
		buffer[buffer_ix++] = '-';
		n = -n;
	}

	do
	{
		temp[temp_ix++] = '0' + (uint8_t) (n % 10);
		n = n / 10;

	} while(n);

	while(temp_ix)
		buffer[buffer_ix++] = temp[--temp_ix];

	buffer[buffer_ix] = 0;

	return buffer;
}


void debug(const char *frmt, ...)
{
	va_list args;
	va_start(args, frmt);
	char temp[64];

	while(*frmt)
	{
		if(*frmt == '%')
		{
			switch(*(frmt+1))
			{
				case 'd':
					debug("%s", toDec(temp, 64, va_arg(args, int)));
					break;

				case 'x':
					debug("%s", toHex(temp, 64, (unsigned) va_arg(args, int)));
					break;

				case 'b':
					debug("%s", toBin(temp, 64, (unsigned) va_arg(args, int)));
					break;

				case 's':
					debug(va_arg(args, const char*));
					break;

				case 'c':
					mini_uart_putc((char) va_arg(args, int));
					break;

				default:
					mini_uart_putc(*frmt);
					mini_uart_putc(*(frmt+1));
					break;
			}

			frmt += 2;
		}
		else
		{
			mini_uart_putc(*frmt++);
		}
	}

	va_end(args);
}
