#ifndef __GPIO_CONTROLLER_H__
#define __GPIO_CONTROLLER_H__

#include <stdint.h>

#define GPIO_CONTROLLER_ADDR 0x20200000

typedef struct GPIO
{
	uint32_t function_select_0;
	uint32_t function_select_1;
	uint32_t function_select_2;
	uint32_t function_select_3;
	uint32_t function_select_4;
	uint32_t function_select_5;
	uint32_t reserved_0;
	uint32_t output_set_0;
	uint32_t output_set_1;
	uint32_t reserved_1;
	uint32_t output_clear_0;
	uint32_t output_clear_1;
	uint32_t reserved_3;
	uint32_t level_0;
	uint32_t level_1;
	uint32_t reserved_4;
	uint32_t event_detect_status_0;
	uint32_t event_detect_status_1;
	uint32_t reserved_5;
	uint32_t rising_edge_detect_enable_0;
	uint32_t rising_edge_detect_enable_1;
	uint32_t reserved_6;
	uint32_t falling_edge_detect_enable_0;
	uint32_t falling_edge_detect_enable_1;
	uint32_t reserved_7;
	uint32_t high_detect_enable_0;
	uint32_t high_detect_enable_1;
	uint32_t reserved_8;
	uint32_t low_detect_enable_0;
	uint32_t low_detect_enable_1;
	uint32_t reserved_9;
	uint32_t async_rising_edge_detect_0;
	uint32_t async_rising_edge_detect_1;
	uint32_t reserved_10;
	uint32_t async_falling_edge_detect_0;
	uint32_t async_falling_edge_detect_1;
	uint32_t reserved_11;
	uint32_t pull_up_down_enable;
	uint32_t pull_up_down_enable_clock_0;
	uint32_t pull_up_down_enable_clock_1;
	
} GPIO;

#define FSEL_INPUT 0b000
#define FSEL_OUTPUT 0b001
#define FSEL_ALT0 0b100
#define FSEL_ALT1 0b101
#define FSEL_ALT2 0b110
#define FSEL_ALT3 0b111
#define FSEL_ALT4 0b011
#define FSEL_ALT5 0b010

#endif /* __GPIO_CONTROLLER_H__ */