#ifndef __MUTEX_H__
#define __MUTEX_H__

#include <stdint.h>
#include <queue.h>
#include <process.h>
#include <scheduler.h>
#include <debug.h>

#define MUTEX_LOCKED 1
#define MUTEX_UNLOCKED 0

typedef struct mutex_t mutex_t;

struct mutex_t
{
	int state;
	process_t *owner; // No utilizado.
	Queue *queue;
};

extern Vector *mutexes;

void mutex_init();
int mutex_create();
void mutex_adquire(int key);
void mutex_release(int key);

#endif /* __MUTEX_H__ */
