#include <syscall.h>

uint32_t swi_table[SWI_SIZE];

// Tabla de syscalls

void swi_init()
{
	for(int i = 0; i < SWI_SIZE; i++) swi_table[i] = 0;

	swi_install(SWI_GPIO_CLEAR, gpio_clear);
	swi_install(SWI_GPIO_SET, gpio_set);
	swi_install(SWI_GPIO_FSEL, gpio_fsel);

	swi_install(SWI_SLEEP, sleep);

	swi_install(30, getSystemTimerCounter);

	swi_install(SWI_GETPID, getpid);

	swi_install(SWI_FORK, fork);
	swi_install(SWI_EXEC, exec);
	swi_install(SWI_WAIT, wait);
	swi_install(SWI_QUIT, quit);

	swi_install(SWI_GETCH, getch);
	swi_install(SWI_PUTCH, putch);

	swi_install(SWI_MUTEX_CREATE, mutex_create);
	swi_install(SWI_MUTEX_ADQUIRE, mutex_adquire);
	swi_install(SWI_MUTEX_RELEASE, mutex_release);

	swi_install(SWI_SHARED_CREATE, shared_create);
        
        swi_install(SWI_MALLOC, malloc);
        swi_install(SWI_FREE, free);
}

