#include <stdint.h>
#include <utils.h>
#include <speaker.h>

#define SONG01_SIZE 25

uint32_t song01[2][SONG01_SIZE] = {
	{ e, e, e, c, e, g, G, c, G, E, A, B, Bb, A, G, e, g, a, f, g, e, c, d, B, c },
	{ 6, 12, 12, 6, 12, 24, 24, 18, 18, 18, 12, 12, 6, 12, 8, 8, 8, 12, 6, 12, 12, 6, 6, 6, 12 }
};

//Mario main theme melody

#define SONG02_SIZE 78

uint32_t song02[2][SONG02_SIZE] = { {
  NOTE_E7, NOTE_E7, 0, NOTE_E7, 
  0, NOTE_C7, NOTE_E7, 0,
  NOTE_G7, 0, 0, 0,
  NOTE_G6, 0, 0, 0, 

  NOTE_C7, 0, 0, NOTE_G6, 
  0, 0, NOTE_E6, 0, 
  0, NOTE_A6, 0, NOTE_B6, 
  0, NOTE_AS6, NOTE_A6, 0, 

  NOTE_G6, NOTE_E7, NOTE_G7, 
  NOTE_A7, 0, NOTE_F7, NOTE_G7, 
  0, NOTE_E7, 0,NOTE_C7, 
  NOTE_D7, NOTE_B6, 0, 0,

  NOTE_C7, 0, 0, NOTE_G6, 
  0, 0, NOTE_E6, 0, 
  0, NOTE_A6, 0, NOTE_B6, 
  0, NOTE_AS6, NOTE_A6, 0, 

  NOTE_G6, NOTE_E7, NOTE_G7, 
  NOTE_A7, 0, NOTE_F7, NOTE_G7, 
  0, NOTE_E7, 0,NOTE_C7, 
  NOTE_D7, NOTE_B6, 0, 0 },
  {
  12, 12, 12, 12, 
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12, 

  12, 12, 12, 12,
  12, 12, 12, 12, 
  12, 12, 12, 12, 
  12, 12, 12, 12, 

  9, 9, 9,
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,

  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,

  9, 9, 9,
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,
}
};

int pin = 22;

void tone(uint32_t *halfPeriod, uint32_t frewq);

int main()
{
	gpio_fsel(pin, FSEL_OUTPUT);
	gpio_set(pin);

	int child;
	uint32_t *halfPeriod = share_mem();

	*halfPeriod = 0;

	child = fork();

	if(child != 0)
	{
		print("Yo soy speaker (pid %d), leo %x para saber que nota sigue.\n", getpid(), (uint32_t) halfPeriod);

		while(1)
		{
	    	gpio_set(pin);
			usleep(*halfPeriod);
	    	gpio_clear(pin);
			usleep(*halfPeriod);
		}
	}
	else
	{
		gpio_fsel(8, FSEL_OUTPUT);
		gpio_clear(8);

		uint32_t note, duration, pause;

		print("Yo soy hijo de speaker (pid %d), escribo la nota en %x y controlo su duración.\n", getpid(), (uint32_t) halfPeriod);

		while(1)
		{
			for(int i = 0; i < SONG02_SIZE; i++)
			{
				note = song02[0][i];
				duration = 1000 / song02[1][i];
				pause = (duration * 30) / 100;

				tone(halfPeriod, note);
				gpio_set(8);
				sleep(duration);

				tone(halfPeriod, 0);
				gpio_clear(8);
				sleep(pause);
			}
		}
	}

	return 0;
}

void tone(uint32_t *halfPeriod, uint32_t frewq)
{
	if(frewq < 1)
		*halfPeriod = 0;
	else if(frewq > 5000)
		*halfPeriod = 500000;
	else
		*halfPeriod = 500000 / frewq;
}
